# coding: utf-8

"""
Fitbit Web API Explorer

Fitbit provides a Web API for accessing data from Fitbit activity trackers, Aria scale, and manually entered logs. Anyone can develop an application to access and modify a Fitbit user's data on their behalf, so long as it complies with Fitbit Platform Terms of Service. These Swagger UI docs do not currently support making Fitbit API requests directly. In order to make a request, construct a request for the appropriate endpoint using this documentation, and then add an Authorization header to each request with an access token obtained using the steps outlined here: https://dev.fitbit.com/build/reference/web-api/developer-guide/authorization/.  # noqa: E501

OpenAPI spec version: 1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from fitbit_web_api.api_client import ApiClient


class ElectrocardiogramApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def get_ecg_log_list(self, sort, offset, limit, **kwargs):  # noqa: E501
        """Get ECG Log List  # noqa: E501

        This endpoint is used for querying the user's on-device ECG readings.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_ecg_log_list(sort, offset, limit, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sort: The sort order of entries by date asc (ascending) or desc (descending). (required)
        :param int offset: The offset number of entries. (required)
        :param int limit: The maximum number of entries returned (maximum;10). (required)
        :param date before_date: The date in the format yyyy-MM-ddTHH:mm:ss. Only yyyy-MM-dd is required. Either beforeDate or afterDate should be specified.
        :param date after_date: The date in the format yyyy-MM-ddTHH:mm:ss.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs["_return_http_data_only"] = True
        if kwargs.get("async_req"):
            return self.get_ecg_log_list_with_http_info(
                sort, offset, limit, **kwargs
            )  # noqa: E501
        else:
            (data) = self.get_ecg_log_list_with_http_info(
                sort, offset, limit, **kwargs
            )  # noqa: E501
            return data

    def get_ecg_log_list_with_http_info(
        self, sort, offset, limit, **kwargs
    ):  # noqa: E501
        """Get ECG Log List  # noqa: E501

        This endpoint is used for querying the user's on-device ECG readings.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_ecg_log_list_with_http_info(sort, offset, limit, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str sort: The sort order of entries by date asc (ascending) or desc (descending). (required)
        :param int offset: The offset number of entries. (required)
        :param int limit: The maximum number of entries returned (maximum;10). (required)
        :param date before_date: The date in the format yyyy-MM-ddTHH:mm:ss. Only yyyy-MM-dd is required. Either beforeDate or afterDate should be specified.
        :param date after_date: The date in the format yyyy-MM-ddTHH:mm:ss.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = [
            "sort",
            "offset",
            "limit",
            "before_date",
            "after_date",
        ]  # noqa: E501
        all_params.append("async_req")
        all_params.append("_return_http_data_only")
        all_params.append("_preload_content")
        all_params.append("_request_timeout")

        params = locals()
        for key, val in six.iteritems(params["kwargs"]):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_ecg_log_list" % key
                )
            params[key] = val
        del params["kwargs"]
        # verify the required parameter 'sort' is set
        if "sort" not in params or params["sort"] is None:
            raise ValueError(
                "Missing the required parameter `sort` when calling `get_ecg_log_list`"
            )  # noqa: E501
        # verify the required parameter 'offset' is set
        if "offset" not in params or params["offset"] is None:
            raise ValueError(
                "Missing the required parameter `offset` when calling `get_ecg_log_list`"
            )  # noqa: E501
        # verify the required parameter 'limit' is set
        if "limit" not in params or params["limit"] is None:
            raise ValueError(
                "Missing the required parameter `limit` when calling `get_ecg_log_list`"
            )  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if "before_date" in params:
            query_params.append(("beforeDate", params["before_date"]))  # noqa: E501
        if "after_date" in params:
            query_params.append(("afterDate", params["after_date"]))  # noqa: E501
        if "sort" in params:
            query_params.append(("sort", params["sort"]))  # noqa: E501
        if "offset" in params:
            query_params.append(("offset", params["offset"]))  # noqa: E501
        if "limit" in params:
            query_params.append(("limit", params["limit"]))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ["oauth2"]  # noqa: E501

        return self.api_client.call_api(
            "/1/user/-/ecg/list.json",
            "GET",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get("async_req"),
            _return_http_data_only=params.get("_return_http_data_only"),
            _preload_content=params.get("_preload_content", True),
            _request_timeout=params.get("_request_timeout"),
            collection_formats=collection_formats,
        )
