# coding: utf-8

"""
Fitbit Web API Explorer

Fitbit provides a Web API for accessing data from Fitbit activity trackers, Aria scale, and manually entered logs. Anyone can develop an application to access and modify a Fitbit user's data on their behalf, so long as it complies with Fitbit Platform Terms of Service. These Swagger UI docs do not currently support making Fitbit API requests directly. In order to make a request, construct a request for the appropriate endpoint using this documentation, and then add an Authorization header to each request with an access token obtained using the steps outlined here: https://dev.fitbit.com/build/reference/web-api/developer-guide/authorization/.  # noqa: E501

OpenAPI spec version: 1

Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class Meal(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        "name": "str",
        "description": "str",
        "meal_foods": "list[FoodItem]",
    }

    attribute_map = {
        "name": "name",
        "description": "description",
        "meal_foods": "mealFoods",
    }

    def __init__(self, name=None, description=None, meal_foods=None):  # noqa: E501
        """Meal - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._meal_foods = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if meal_foods is not None:
            self.meal_foods = meal_foods

    @property
    def name(self):
        """Gets the name of this Meal.  # noqa: E501


        :return: The name of this Meal.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Meal.


        :param name: The name of this Meal.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this Meal.  # noqa: E501


        :return: The description of this Meal.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Meal.


        :param description: The description of this Meal.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def meal_foods(self):
        """Gets the meal_foods of this Meal.  # noqa: E501


        :return: The meal_foods of this Meal.  # noqa: E501
        :rtype: list[FoodItem]
        """
        return self._meal_foods

    @meal_foods.setter
    def meal_foods(self, meal_foods):
        """Sets the meal_foods of this Meal.


        :param meal_foods: The meal_foods of this Meal.  # noqa: E501
        :type: list[FoodItem]
        """

        self._meal_foods = meal_foods

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(
                    map(lambda x: x.to_dict() if hasattr(x, "to_dict") else x, value)
                )
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(
                    map(
                        lambda item: (
                            (item[0], item[1].to_dict())
                            if hasattr(item[1], "to_dict")
                            else item
                        ),
                        value.items(),
                    )
                )
            else:
                result[attr] = value
        if issubclass(Meal, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Meal):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
